-- Se actualiza la tabla z_bib con los nuevos datos de conexión a Rebeca

UPDATE z_bib SET bib_nom = 'REBECA', url = 'catalogos.mecd.es', port = '220', base = 'ABNET_REBECA', format ='ISO 8859-1' WHERE url = 'rebeca.mcu.es' || url='rebeca_z3950.mcu.es';

-- Se añade una acción personalizada para renovar usuarios

Insert into procs (name,requete,comment,autorisations, parameters,num_classement,proc_notice_tpl,proc_notice_tpl_field) select 'LLIUREX_RENOV:Canvi de data de finalització de l\'abonament ','Update empr set empr_date_expiration=\'!!date!!\' where empr_date_expiration<curdate()','Acció per a renovar als usuaris que tenen caducat l\'abonament','1','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccione la nova data de caducitat:]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>',20,0,'' from dual where NOT EXISTS(Select * from procs where name like 'LLIUREX_RENOV%');


DELIMITER $$

DROP PROCEDURE IF EXISTS alter_table_addfield $$
CREATE PROCEDURE alter_table_addfield()
BEGIN

IF NOT EXISTS( (SELECT * FROM information_schema.COLUMNS WHERE TABLE_SCHEMA='pmb' AND COLUMN_NAME='field_position' AND TABLE_NAME='notices_mots_global_index') ) THEN
    ALTER TABLE notices_mots_global_index ADD field_position int not null default 1;

END IF;    

END $$

CALL alter_table_addfield() $$

DROP PROCEDURE IF EXISTS alter_table_addfield $$
DELIMITER ;
